<?php
	
	$MYSQL_HOST = '127.0.0.1';
	$MYSQL_USERNAME = 'root';
	$MYSQL_PASSWORD = '';
	$MYSQL_DATABASE = 'pow';
	
	include 'pbkdf2.php';
	
	function getCertInfo() {
		$cert = $_SERVER['SSL_SERVER_CERT'];
		openssl_x509_export($cert, $output, true);
		$output = preg_replace('/\-+BEGIN CERTIFICATE\-+/','',$output);
		$output = preg_replace('/\-+END CERTIFICATE\-+/','',$output);
		$output = trim($output);
		$output = str_replace( array("\n\r","\n","\r"), '', $output);
		$bin = base64_decode($output);
		$hash = sha1($bin);
		$hash = strtolower($hash);
		return $hash;
	}
	
	// initialize ECC library
	function __autoload($f) {
		// load the interfaces first otherwise contract errors occur
		$interfaceFile = "ecc_library/classes/interface/" . $f . "Interface.php";
		if (file_exists($interfaceFile)) {
			require_once $interfaceFile;
		}
		// load class files after interfaces
		$classFile = "ecc_library/classes/" . $f . ".php";
		if (file_exists($classFile)) {
			require_once $classFile;
		}
		// if utilities are needed load them last
		$utilFile = "ecc_library/classes/util/" . $f . ".php";
		if (file_exists($utilFile)) {
			require_once $utilFile;
		}
	}
	
	// set GMP
	if (extension_loaded('gmp') && !defined('USE_EXT')) {
		define ('USE_EXT', 'GMP');
	} else if (extension_loaded('bcmath') && !defined('USE_EXT')) {
		define ('USE_EXT', 'BCMATH');
	}
	
	$link = mysql_connect($MYSQL_HOST, $MYSQL_USERNAME, $MYSQL_PASSWORD);
	mysql_select_db($MYSQL_DATABASE);
	
	// receive the first client message
	if (isset($_REQUEST['msg']) && ($_REQUEST['msg'] === "POWClientExchange")) {
		
		if (!(isset($_REQUEST['version']) && isset($_REQUEST['sessionID']) && isset($_REQUEST['username']) && isset($_REQUEST['clientPoint']))) {
			$returnvalue = array("msg" => "ERROR",
								 "error" => "Invalid request."
								 );
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
			return;
		}
		
		if (!($_REQUEST['version'] === "POW_v1_tSOKE_secp192r1_SHA256_certHash")) {
			$returnvalue = array("msg" => "ERROR_UNSUPPORTED_VERSION",
								 "sessionID" => $_REQUEST['sessionID']
								 );
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
			exit;
		}
		
		// look up hash and salt for this account
		$username = $_REQUEST['username'];
		$result = mysql_query("SELECT * FROM users WHERE username='" . mysql_real_escape_string($username) . "'");
		if (mysql_num_rows($result) == 0) {
			$returnvalue = array("msg" => "ERROR_USERNAME_NOT_FOUND",
								 "sessionID" => $_REQUEST['sessionID']
								 );
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
			exit;
		}
		$row = mysql_fetch_array($result, MYSQL_BOTH);
		$h1 = $row['hash'];
		$salt = $row['salt'];
		
		$result = mysql_query("SELECT * FROM sessions WHERE sessionID='" . mysql_real_escape_string($_REQUEST['sessionID']) . "'");
		if (mysql_num_rows($result) == 0) {
			$returnvalue = array("msg" => "ERROR_SESSION_NOT_FOUND",
								 "sessionID" => $_REQUEST['sessionID']
								 );
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
			exit;
		}
		$row = mysql_fetch_array($result, MYSQL_BOTH);

		// ECC parameters
		$n = 6277101735386680763835789423176059013767194773182842284081;
		$gprimeX = gmp_init("8da36f68628a18107650b306f22b41448cb60fe5712dd57a", 16);
		$gprimeY = gmp_init("1f64a649852124528a09455de6aad151b4c0a9a8c2e8269c", 16);
		$g = NISTcurve::generator_192();
		
		// Y <- yG
		$serverECDH = new EcDH($g);
		$serverPub = $serverECDH->getPublicPoint();
		
		// X
		$clientPub = Point::decodePoint(NISTcurve::curve_192(), $_REQUEST['clientPoint']);
		
		// Z <- yX
		$serverECDH->setPublicPoint($clientPub);
		$serverECDH->calculateKey();
		$Z = $serverECDH->getAgreedKey();
		
		// Y^* <- Y + (h mod n) G'
		$gprime = new Point($g->getCurve(), $gprimeX, $gprimeY);
		$hGprime = Point::mul(gmp_init($h1,16),$gprime);
		$ystar = Point::add($serverPub,$hGprime);
		
		// compute outgoing message (salt, Y^*)
		$returnvalue = array("msg" => "POWServerExchange",
							 "sessionID" => $_REQUEST['sessionID'],
							 "salt" => $salt,
							 "serverPoint" => $ystar->getEncodedPoint($g->getOrder()),
							 );
						
		$returnvalue = json_encode($returnvalue);
		
		// k <- SHA-256(POWServerHello, POWClientExchange, POWServerExchange, passHash, certHash, sharedSecret)
		$k1  = "POWServerHello=" . rawurlencode($row['msgPOWServerHello']);
		$k1 .= "&POWClientExchange=" . rawurlencode(file_get_contents("php://input"));
		$k1 .= "&POWServerExchange=" . rawurlencode($returnvalue);
		$k1 .= "&passHash=" . $h1;
		$k1 .= "&certHash=" . getCertInfo();
		$k1 .= "&sharedSecret=" . $Z->getEncodedPoint($g->getOrder());
		
		$k1 = hash("sha256", $k1);
		
		// A1 <- SHA-256(K, "auth1")
		$a1 = hash("sha256", $k1 . "&auth1");
		
		// A2 <- SHA-256(K, "auth2")
		$a2 = hash("sha256", $k1 . "&auth2");
		
		// store session variables
		mysql_query("UPDATE sessions SET "
					. "username='" . mysql_real_escape_string($username) . "', "
					. "a1='" . mysql_real_escape_string($a1) . "', "
					. "a2='" . mysql_real_escape_string($a2) . "'"
					. " WHERE sessionID='" . mysql_real_escape_string($_REQUEST['sessionID']) . "'");
		
		echo $returnvalue;
		
		// receive the second client message
	} else if (isset($_REQUEST['msg']) && ($_REQUEST['msg'] == "POWClientFinished")) {
		
		if (!isset($_REQUEST['auth1']) || !isset($_REQUEST['sessionID'])) {
			$returnvalue = array("msg" => "ERROR", "error" => "Invalid request.");
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
			return;
		}
		
		$result = mysql_query("SELECT * FROM sessions WHERE sessionID='" . mysql_real_escape_string($_REQUEST['sessionID']) . "'");
		if (mysql_num_rows($result) == 0) {
			$returnvalue = array("msg" => "ERROR_SESSION_NOT_FOUND",
								 "sessionID" => $_REQUEST['sessionID']
								 );
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
			exit;
		}
		$row = mysql_fetch_array($result, MYSQL_BOTH);
		
		$a1 = base64_decode($_REQUEST['auth1']);
		if(strcasecmp($a1, $row['a1']) == 0) {
			$returnvalue = array("msg" => "POWServerFinished",
								 "sessionID" => $_REQUEST['sessionID'],
								 "auth2" => $row['a2'],
								 "successURL" => $row['successURL'],
								 );
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
		} else {
			$returnvalue = array("msg" => "ERROR_INVALID_PASSWORD",
								 "sessionID" => $_REQUEST['sessionID']
								 );
			$returnvalue = json_encode($returnvalue);
			echo $returnvalue;
		}
	}
	
?>
